global raw "$path/raw_data"
global work "$path/working_data"

use "$raw/cfps2012adultcombined_112014.dta", clear 

	gen female2012=1-cfps2012_gender_best
	gen age2012=cfps2012_age
	gen marriage2012=qe104
	gen work2012=qg101
	replace work=0 if work==5
	gen hukou2012=qa301
	gen edu_f=qv102
	gen party_f=qv104
	gen occupation_f=qv103code_best
	gen occupation_f_isco88=qv103_isco
	gen edu_m=qv202
	gen party_m=qv204
	gen occupation_m=qv203code_best
	gen occupation_m_isco88=qv203_isco
	gen income2012=income 
	gen income_adj2012=income_ad
	drop income income_adj 
	foreach x in edu2012 eduy2012 female2012 age2012 marriage2012 work2012 hukou2012 edu_f party_f occupation_f edu_m party_m occupation_m income2012 income_adj2012 {
	replace `x' =. if `x'<0
	}

	keep provcd countyid cid pid edu2012 eduy2012 female work hukou age marriage* income* *_m *_f 
	drop ks9total_m ksa1total_m pid_f pid_m


*** Merge with 2010 adult samples 
merge 1:1 pid using "$work/adult10.dta"
keep if _m==3
keep provcd countyid cid pid ed* female work* hukou* age* marriage* income* *_m *_f 
ren tb1b_a_m age_m2010 
ren tb1b_a_f age_f2010
ren tb4_a_f schlv_f2010
ren tb4_a_m schlv_m2010 
ren marriage_s marriage2010
	replace alive_a_f=. if alive_a_f<0
	replace alive_a_m=. if alive_a_m<0
keep provcd countyid cid pid ed* female work* hukou* age* marriage* income* alive_a_* schlv* 
drop edu educ eduy edul
foreach x of varlist schlv* age* prov cid county income work* marriage* hukou* {
replace `x'=. if `x'<0
}
drop schlv*  edu2010_t1_best
ren hukou hukou2010 
ren age age2010 
ren work work2010
ren income income2010 


** Reshape into Long Dataset 
reshape long edu eduy marriage age hukou work income ctfwork_20_40 ctmwork_20_40 ctfinc_20_40 ctminc_20_40 ///
ctfwork_20_50 ctmwork_20_50 ctfinc_20_50 ctminc_20_50 ctfwork_20_45 ctmwork_20_45 ctfinc_20_45 ctminc_20_45 ///
ctfwork_25_50 ctmwork_25_50 ctfinc_25_50 ctminc_25_50 ctfwork_25_40 ctmwork_25_40 ctfinc_25_40 ctminc_25_40 ///
ctfwork_25_45 ctmwork_25_45 ctfinc_25_45 ctminc_25_45 , i(pid) j(year) 
replace hukou=. if hukou>3
gen edyr_fm=eduy*female 
gen age2 = age^2 
gen edyr2=eduy^2 
egen county_yr=group(county year)
egen age_p=rowmean(age_f age_m) 

save "$work/adult1012.dta", replace 
