global raw "$path/raw_data"
global work "$path/working_data"

**====================================**
** AGE STRUCTURE 2012 

use "$raw/cfps2012famconf_112014.dta", clear 
keep pid fid12 tb1b_a_p tb2_a_p alive_a_p tb3_a12_p tb4_a12_p qa301_a12_p co_a12_p
keep if co_a12_p==1 
bysort pid: gen rpt=_n 
drop rpt co_a12_p 
drop alive 
ren tb1b_a_p age
ren tb2_a_p male
ren tb3_a12_p marriage
ren tb4_a12_p edu_lv
ren qa301_a12_p hukou
gen relation="self"
gen pid_self=pid 

replace age=. if age<0
	gen n_m_0_6 = (male == 1 & age>=0 & age<=6)
	gen n_m_7_16 = (male == 1 & age>6 & age <=16) 
	gen n_m_17_25 = (male == 1 & age>16 & age <=25)
	gen n_m_26_40 = (male == 1 & age>25 & age <=40)
	gen n_m_41_60 = (male == 1 & age>40 & age <=60)
	gen n_m_61_80 = (male == 1 & age>60 & age <=80)
	gen n_m_81_ = (male == 1 & age>80 )

	gen n_f_0_6 = (male == 0 & age>=0 & age<=6)
	gen n_f_7_16 = (male == 0 & age>6 & age <=16) 
	gen n_f_17_25 = (male == 0 & age>16 & age <=25)
	gen n_f_26_40 = (male == 0 & age>25 & age <=40)
	gen n_f_41_60 = (male == 0 & age>40 & age <=60)
	gen n_f_61_80 = (male == 0 & age>60 & age <=80)
	gen n_f_81_ = (male ==0 & age>80 )

bysort fid12: egen m_0_6=sum(n_m_0_6)
bysort fid12: egen m_7_16=sum(n_m_7_16)
bysort fid12: egen m_17_25=sum(n_m_17_25)
bysort fid12: egen m_26_40=sum(n_m_26_40)
bysort fid12: egen m_41_60=sum(n_m_41_60)
bysort fid12: egen m_61_80=sum(n_m_61_80)
bysort fid12: egen m_81_=sum(n_m_81_)
bysort fid12: egen f_0_6=sum(n_f_0_6)
bysort fid12: egen f_7_16=sum(n_f_7_16)
bysort fid12: egen f_17_25=sum(n_f_17_25)
bysort fid12: egen f_26_40=sum(n_f_26_40)
bysort fid12: egen f_41_60=sum(n_f_41_60)
bysort fid12: egen f_61_80=sum(n_f_61_80)
bysort fid12: egen f_81_=sum(n_f_81_)
drop n_m* n_f* 

bysort fid12: gen rpt=_n 
keep if rpt==1 
drop rpt 
drop pid_self 
drop pid age male marriage edu_lv hukou relation 
save "$work/age_structure_12.dta", replace 

**====================================**
** AGE STRUCTURE 2010 

use "$raw/cfps2010famconf_report_nat092014.dta", clear 
keep pid fid  tb2_a_p birthy_best tb1y_a_p tb1b_a_p alive_a_p tb3_a_p tb4_a_p tb6_a_p co_p td8_a_p
ren tb2_a_p male
ren tb1b_a_p age
ren tb3_a_p marriage
ren tb4_a_p edu_lv
drop co_p td8_a_p
drop alive_a_p
replace age=2010- birthy_best if age<0 & birthy_best>0
replace age=. if age<0
drop tb1y_a_p
replace birthy_best=. if birthy_best <0 
drop birthy
drop tb6_a_p

replace age=. if age<0
	gen n_m_0_6 = (male == 1 & age>=0 & age<=6)
	gen n_m_7_16 = (male == 1 & age>6 & age <=16) 
	gen n_m_17_25 = (male == 1 & age>16 & age <=25)
	gen n_m_26_40 = (male == 1 & age>25 & age <=40)
	gen n_m_41_60 = (male == 1 & age>40 & age <=60)
	gen n_m_61_80 = (male == 1 & age>60 & age <=80)
	gen n_m_81_ = (male == 1 & age>80 )

	gen n_f_0_6 = (male == 0 & age>=0 & age<=6)
	gen n_f_7_16 = (male == 0 & age>6 & age <=16) 
	gen n_f_17_25 = (male == 0 & age>16 & age <=25)
	gen n_f_26_40 = (male == 0 & age>25 & age <=40)
	gen n_f_41_60 = (male == 0 & age>40 & age <=60)
	gen n_f_61_80 = (male == 0 & age>60 & age <=80)
	gen n_f_81_ = (male ==0 & age>80 )

bysort fid: egen m_0_6=sum(n_m_0_6)
bysort fid: egen m_7_16=sum(n_m_7_16)
bysort fid: egen m_17_25=sum(n_m_17_25)
bysort fid: egen m_26_40=sum(n_m_26_40)
bysort fid: egen m_41_60=sum(n_m_41_60)
bysort fid: egen m_61_80=sum(n_m_61_80)
bysort fid: egen m_81_=sum(n_m_81_)
bysort fid: egen f_0_6=sum(n_f_0_6)
bysort fid: egen f_7_16=sum(n_f_7_16)
bysort fid: egen f_17_25=sum(n_f_17_25)
bysort fid: egen f_26_40=sum(n_f_26_40)
bysort fid: egen f_41_60=sum(n_f_41_60)
bysort fid: egen f_61_80=sum(n_f_61_80)
bysort fid: egen f_81_=sum(n_f_81_)
drop n_m* n_f* 
bysort fid: gen rpt=_n 
keep if rpt==1 
drop rpt 

drop pid age male marriage edu_lv  
ren fid fid10
save "$work/age_structure_10.dta", replace 
