global raw "$path/raw_data"
global work "$path/working_data"

*==========================================================*
**                Children Samples  2012                  **
*==========================================================*
use "$raw/cfps2012famconf_112014.dta", clear 

ren tb1b_a_p age
keep if co_a12_p==1
gen father=1
replace father=0 if alive_a_f==0
replace father=0 if alive_a_f<0 & co_a12_f==0 & tb6_a12_f==0
gen mother=1 
replace mother=0 if alive_a_m==0 
replace mother=0 if alive_a_m<0 & co_a12_m==0 & tb6_a12_m==0
replace pid_f=. if pid_f<0
replace pid_m=. if  pid_m<0
replace pid_f=. if father==.
replace pid_m=. if mother==.
ren tb4_a12_p edu_c 
ren tb4_a12_f edu_f 
ren tb4_a12_m edu_m 
ren qa301_a12_f hukou_f 
ren qa301_a12_m hukou_m 
ren tb1b_a_f age_f 
ren tb1b_a_m age_m 
ren tb2_a_p gender 
ren qa301_a12_p hukou 
ren tb3_a12_p marriage 
gen local_f=1 if qa302_a12_f==1 | qa302_a12_f==2  | qa302_a12_f==3  
gen local_m=1 if qa302_a12_m==1 | qa302_a12_m==2  | qa302_a12_m==3

keep if qa302_a12_p==1 | qa302_a12_p==2 | qa302_a12_p==3

keep fid12 fid10 pid age* gender hukou* marriage father mother edu* pid_f pid_m alive* local_* 

foreach x in fid10 age edu_c edu_f edu_m hukou hukou_f hukou_m age_f age_m marriage gender ///
	alive_a_p alive_a_f alive_a_m	{ 
replace `x'=. if `x'<0
}
tab age,m 
ren alive_a_f alive_f 
ren alive_a_m alive_m 
drop alive_a_c* alive_a_s* alive_a_p 
save "$work/fam12.dta", replace 

keep if age<=30 
save "$work/ch12_tem.dta", replace 

	** merge with father's parents' information 
	use "$work/ch12_tem.dta", clear
	ren * *_o
	ren pid_f_o pid 
	merge m:1 pid using "$work/fam12.dta", keepusing(alive* age_f age_m)
	ren age_f age_ff 
	ren age_m age_fm 
	ren alive_f alive_ff
	ren alive_m alive_fm 
	drop if _m==2
	drop _m 
	ren pid pid_f_o 
	
	** merge with mother's parents' information 
	ren pid_m_o pid 
	merge m:1 pid using "$work/fam12.dta", keepusing(alive* age_f age_m)
	ren age_f age_mf 
	ren age_m age_mm 
	ren alive_f alive_mf
	ren alive_m alive_mm 
	drop if _m==2
	drop _m 
	ren pid pid_m_o 
	ren *_o *
	
save "$work/ch12_tem.dta", replace 

** education information 
use "$work/ch12_tem.dta", clear 
ren pid_f pidF 
ren pid_m pidM 
merge 1:1 pid using "$raw/cfps2012childcombined_112014.dta"
drop if _merge==2


replace pid_f=. if pid_f<0
replace pid_m=. if pid_m<0
drop pidF pidM 
drop _merge 

gen edu_exp= wd5total
replace edu_exp=wd5total_m if mi(wd5total) & !mi(wd5total_m)
replace edu_exp=wd5total_m if wd5ckp==1 & !mi(wd5total_m)
replace edu_exp=wd5total_m if wd5ckp==3 & !mi(wd5total_m)
replace  edu_exp=. if wd5total<0
gen work=1 if  qg101==1 
replace work=0 if qg101==5
replace work=1 if qg103==1 
replace work=1 if qg102==1 
ren work employ
gen at_sch= wf3m
replace at_sch=. if wf3m<0
ren wf301m sch_lv_c
replace at_sch=0 if at_sch==1 & wc01==0 & wc01ckp1==1 
replace at_sch=1 if at_sch==0 & wc01==1 & wc01ckp1==1 
replace at_sch=1 if at_sch==. & wc01==1 & wc01ckp1==1 
replace at_sch=0 if at_sch==. & wc01==0 & wc01ckp1==1 
replace sch_lv_c=2 if kr1==2 & at_sch!=wf3m & at_sch==1 
replace sch_lv_c=3 if kr1==3 & at_sch!=wf3m & at_sch==1 
replace sch_lv_c=4 if kr1==4 & at_sch!=wf3m & at_sch==1 
replace sch_lv=. if sch_lv<0
replace edu_exp=. if edu_exp<0
foreach x in wd508 wd507 wd501 wd502a wd511 wd505m wd512 wd513 wd504 wd503m wd577{
replace `x'=. if `x'<0
}

egen edu_exp_cal=rowtotal(wd508 wd507 wd501 wd502a wd511 wd505m wd512 wd513 wd504 wd503m wd577)
replace edu_exp=edu_exp_cal if at_sch==1 & edu_exp==0 
replace edu_exp=edu_exp_cal if at_sch==1 & edu_exp==.
replace edu_exp=edu_exp_cal if edu_exp==. & !mi(edu_exp_cal)

replace employ=0 if age<16 & employ==. 
drop edu_exp_cal

ren wf501 chinese
ren wf502 math 
forvalues i=1/6 {
replace wf60`i'=. if wf60`i'<0
replace wf60`i'=6-wf60`i'
egen wf60`i'_std=std(wf60`i')
}
egen care_std=rowmean(wf601_std wf602_std wf603_std wf604_std wf605_std wf606_std)
ren wf701 EGrade 
replace EGrade=. if EGrade<0

keep fid12 fid10 pid age* gender hukou* marriage father mother edu* pid_f pid_m ///
	care EG chinese math at_sch sch_lv_c employ income edu_exp  alive* local_* 
drop edu2012 eduy2012
ren income income_c
ren pid_m pid_mc
ren pid_f pid_fc

save "$work/ch12_tem.dta", replace 
 
use  "$work/ch12_tem.dta", clear 
ren pid_f pidF
ren pid_m pidM 

merge 1:1 pid using "$raw/cfps2012adultcombined_112014.dta"
drop if _merge==2

replace pid_f=pidF if _m==1
replace pid_m=pidM if _m==1
replace pid_f=. if pid_f<0
replace pid_m=. if pid_m<0
drop pidF pidM 

tab age _merge 
drop _merge

gen at_sch2=wc01 
replace at_sch2=. if at_sch2<0
replace at_sch2=wc01ckp2 if  wc01ckp1==5
gen sch_lv_a=kr1 
replace sch_lv_a=. if kr1<0 
gen edu_exp2=sa9total 
replace edu_exp2=. if edu_exp2<0
replace edu_exp2=ks9total_m if mi(edu_exp2) & !mi(ks9total_m)
replace edu_exp2=ks9total_m if ks9ckp==3 & !mi(ks9total_m)
replace edu_exp2=ks9total_m if ks9ckp==1 & !mi(ks9total_m)
replace edu_exp2=. if edu_exp2<0
tab at_sch2,m
sum edu_exp2 if at_sch2==0
replace edu_exp2=0 if mi(edu_exp2) & at_sch2==0
sum edu_exp if at_sch==0
replace edu_exp=0 if mi(edu_exp) & at_sch==0

** Construct a unified school level measurement 
tab sch_lv_a,m
forvalues i=2/8{
replace sch_lv_c=`i'+1 if sch_lv_a==`i' & age>15
}
tab sch_lv_c if age>15
replace sch_lv_c=sch_lv_c-1  if !mi(sch_lv_c)
gen sch_lv=sch_lv_c 
drop sch_lv_c 
replace at_sch=at_sch2 if age>15 
replace edu_exp=edu_exp2 if age>15 
replace income_c=income_ad if age>15 
gen em2=1 if qg101==1 
replace em2=0 if qg101==5

replace em2=1 if qg102==1 
replace em2=1 if qg103==1
tab em2 if age>15 
replace employ=em2 if age>15 

keep pid fid12 fid10 age gender marriage edu_c hukou pid_f age_f edu_f hukou_f ///
	pid_m age_m edu_m hukou_m father mother sch_lv income_c edu_exp employ at_sch ///
	care EG chinese math alive* age* local_* 
save "$work/ch12.dta", replace 

use "$raw/cfps2012famecon_112014.dta", clear 
egen cons_exp=rowtotal(food dress house daily med trco eec other)
egen income=rowtotal( wage_1 foperate_1 ftransfer_1 fproperty_1 felse_1)
gen income_adj=fincome1_adj
replace income_adj=income if mi(income_adj) & !mi(income)
sum income income_adj
gen SR=(income-cons_exp)/income*100 
gen SR_adj=(income_adj-cons_exp)/income_adj*100 
gen edu_exp=fp508
replace edu_exp=. if edu_exp<0

keep prov countyid cid urban* fid12 fid10 income* SR* total_ass edu_exp fincome2_adj fincome2_per_adj familysize 
ren income fincome 
ren income_ad fincome_ad
ren edu_exp fedu_exp 

merge 1:m fid12 using "$work/ch12.dta"
drop if _merge!=3 
drop _merge 

drop fincome SR 
ren fincome_ad fincome 
ren SR_ad SR 
foreach x in chinese math{ 
replace `x'=. if `x'<0 
replace `x'=5-`x'
egen `x'_std=std(`x')
drop `x'
}

save "$work/ch12.dta", replace 
 

*==========================================================*
**                Children Samples  2010                  **
*==========================================================*
use "$raw/cfps2010famconf_report_nat092014.dta", clear 
gen age=tb1b_a_p
gen gender=tb2_a_p
gen marriage=tb3_a_p
gen edu_c=tb4_a_p
gen edu_m=meduc
gen edu_f=feduc
gen age_f=2010-fbirthy
gen age_m=2010-mbirthy
gen father=1
replace father=0 if alive_a_f==0
replace father=0 if alive_a_f<0 & tb6_a_f==0 & co_f==0 & tb1b_a_f<0
replace father=0 if alive_a_f<0 & co_f==0
gen mother=1
replace mother=0 if alive_a_m==0
replace mother=0 if alive_a_m<0 & tb6_a_m==0
replace mother=0 if alive_a_m<0 & co_m ==0

keep fid pid pid_f pid_m edu* age* gender marriage mother father fparty mparty alive_a_f alive_a_m 

foreach x in pid pid_f pid_m edu_c edu_f edu_m age age_f age_m gender marriage /// 
	mother father fparty mparty alive_a_f alive_a_m {
replace `x'=. if `x'<0
}
replace edu_c =edu2010_t1_best
drop edu2010* eduy2010
ren alive_a_f alive_f 
ren alive_a_m alive_m 
save "$work/fam10.dta", replace 

keep if age<=30
save "$work/ch10_tem.dta", replace 

	** merge with grandparents' information 
	use "$work/ch10_tem.dta", clear
	ren * *_o
	ren pid_f_o pid 
	merge m:1 pid using "$work/fam10.dta", keepusing(alive* age_f age_m)
	ren age_f age_ff 
	ren age_m age_fm 
	ren alive_f alive_ff
	ren alive_m alive_fm 
	drop if _m==2
	drop _m 
	ren pid pid_f_o 
	
	ren pid_m_o pid 
	merge m:1 pid using "$work/fam10.dta", keepusing(alive* age_f age_m)
	ren age_f age_mf 
	ren age_m age_mm 
	ren alive_f alive_mf
	ren alive_m alive_mm 
	drop if _m==2
	drop _m 
	ren pid pid_m_o 
	ren *_o *
save "$work/ch10_tem.dta", replace 
	
	
** education information 
use "$work/ch10_tem.dta", clear 
ren pid_f pidF
ren pid_m pidM 

merge 1:1 pid using "$raw/cfps2010child_report_nat092014.dta"
drop if _merge==2 
drop pid_f pid_m 
ren pidF pid_f 
ren pidM pid_m 

tab age _merge 
drop _merge 
gen edu_exp=wd5total
replace edu_exp=. if edu_exp<0
gen sch_lv=wf301 
replace sch_lv=. if sch_lv<0
replace sch_lv=1 if wf1==1 
gen at_sch=wf3 
replace at_sch=. if at_sch<0
replace at_sch=1 if wf1==1 & mi(at_sch)
gen hukou=wa4 
replace hukou=. if hukou<0 | hukou>10
replace at_sch=1 if wh1==1 
replace at_sch=0 if wh1==0 
replace sch_lv=kr1 if mi(sch_lv) & kr1>0 & !mi(kr1)
foreach x in wd501 wd502 wd503 wd504 wd505 wd506{
replace `x'=. if `x'<0
}
egen edu_exp_cal=rowtotal(wd501 wd502 wd503 wd504 wd505 wd506)
replace edu_exp=edu_exp_cal if at_sch==1 & edu_exp==0
replace edu_exp=edu_exp_cal if at_sch==0 & edu_exp==.
replace edu_exp=edu_exp_cal if edu_exp==. & !mi(edu_exp_cal)

drop edu_exp_cal

ren wf501 chinese
ren wf502 math 
forvalues i=1/6 {
replace wf60`i'=. if wf60`i'<0
replace wf60`i'=6-wf60`i'
egen wf60`i'_std=std(wf60`i')
}
egen care_std=rowmean(wf601_std wf602_std wf603_std wf604_std wf605_std wf606_std)
ren wf701 EGrade 
replace EGrade=. if EGrade<0

keep fid pid pid_f pid_m edu* age* gender marriage mother father fparty mparty ///
	EGrade care chinese math at_sch hukou sch_lv alive_f* alive_m*  
drop edu edul educ eduy edu2010 edu2010_t1_best eduy2010
save "$work/ch10_tem.dta", replace 

use "$work/ch10_tem.dta", clear
ren pid_f pidF 
ren pid_m pidM 
merge 1:1 pid using "$raw/cfps2010adult_report_nat092014.dta"
drop pid_f pid_m 
ren pidF pid_f
ren pidM pid_m 
drop if _merge==2 

tab age _merge 
drop _merge
gen hk2=qa2
replace hk2=. if hk2<0 | hk2>10
gen at2=qd3
gen sch2=kr1
replace at2=. if at2<0
replace sch2=. if sch2<0
replace sch_lv=6 if sch_lv==5

gen exp2=ks90total 
replace exp2=. if exp2<0
foreach x in ks901 ks902 ks903 ks904 ks905 ks906{
replace `x'=. if `x'<0
}
egen exp2_c=rowtotal(ks901 ks902 ks903 ks904 ks905 ks906)
replace exp2=exp2_c if at2==1 & exp2==0 
replace exp2=0 if at2==0 
replace edu_exp=exp2 if age>15 
replace at_sch=at2 if age>15 
replace sch_lv=sch2 if age>15 
replace hukou=hk2 if age>15 

keep fid pid pid_f pid_m edu* age* gender marriage mother father fparty mparty ///
	EGrade at_sch hukou sch_lv income care chinese math alive_f* alive_m* 
drop edu educ eduy edul edu2010 edu2010_t1_best eduy2010
replace income=0 if age<16
replace income=. if income<0
save "$work/ch10_tem.dta", replace 

use "$raw/cfps2010family_report_nat092014.dta", clear 
egen consup_exp=rowtotal( food dress house daily med trco eec other)
gen SR=(fincome-consup_exp)/fincome*100
ren  fh404 fedu_exp 

keep prov countyid urban* cid fid fincome SR fc1 fc2 fc3 fedu_exp total_asset familysize
ren fc1 visit_rel
ren fc2 visit_fre
ren fc3 gift
merge 1:m fid using "$work/ch10_tem.dta"
drop if _merge!=3
drop _merge 


foreach x in chinese math{ 
replace `x'=. if `x'<0 
replace `x'=5-`x'
egen `x'_std=std(`x')
drop `x'
}



save "$work/ch10.dta", replace 

